// JavaScript Document
var cc;
var cs;

var bW;
var bH;

var cW;
var cH;

var gW;
var gH;

//刻み幅
var stepSize;

var span;

//軌跡を制御する場合
var recCont;
var recData;

var dFlag;

var browse;

var spanArray;

var graphCont;

//
var coef;
var pow;

var nType;

var nNum;

var span;

var nCnt;

var bc0;
var bc1;
var bc2;
var bc3;

//アニメーション用の係数
var gBack;
var gCoef;

var timer1;

var loopFlag;
var waitFlag;
var waitCount;

var timer;

var scTimer;
var scFlag;

function loadContentHandler()
{
	try
	{
		
		//軸の１めもり当たりのドット数
		span = 30;
		
		stepSize = 1;
		
		bW = pageWidth-52;
		bH = pageHeight;
		
		cW = bW;
		cH = bH;
		
		document.getElementById("graphBlock").style.width = bW + "px";
		document.getElementById("graphBlock").style.height = (bH-250) + "px";
		
		$("#graphBlock").css("overflow-y", "scroll");
		
		$("#menuClose").css("display", "none");
		
		document.getElementById("contentCanvas").width = bW;
		document.getElementById("contentCanvas").height = bH-50;
		
		cc = document.getElementById("contentCanvas");
		cs = new createjs.Stage(cc);
		
		createjs.Touch.enable(cs);
		
		$("#suPar").css("position", "absolute");
		$("#suPar").css("cursor", "pointer");
		
		if(ictMode)
		{
			$("#suPar").css("top", 60);
			$("#helpBtn").css("margin-left", -40);
		}
		else
		{
			$("#suPar").css("top", 10);
		}
		
		$("#suPar").css("left", 820);
		
		$("#sdPar").css("position", "absolute");
		$("#sdPar").css("cursor", "pointer");
		$("#sdPar").css("top", 270);
		$("#sdPar").css("left", 820);
		
		$("#suPar").on("mousedown touchstart", startScrollHandler);
		$("#sdPar").on("mousedown touchstart", startScrollHandler);
		
		//背景
		var bg = new createjs.Shape();
		bg.graphics.beginFill("#FFF");
		bg.graphics.drawRect(0, 0, cW, cH-50);
		bg.graphics.endFill();
		
		cs.addChild(bg);
		
		animeFlag = false;
		dFlag = true;
		
		loopFlag = true;
		waitFlag = false;
		waitCount = 10;
		
		graphCont = new createjs.Container();
		cs.addChild(graphCont);
		graphCont.x = 100;
		graphCont.y = 80;
		
		gW = cW-200;
		gH = cH-200;
		
		bc0 = "#FFFFFF";
		bc1 = "#000000";
		//偶数
		bc2 = "#FDFE08";
		//奇数
		bc3 = "#02B3FC";
		
		$(".formLine").css("position", "relative");
		$(".formLine").css("font-size", "0.9em");
		$(".formLine").css("margin-top", "5px");
		
		//式の各部分用classの設定
		$(".formParts").css("position", "relative");
		$(".formParts").css("display", "inline-block");
		$(".formParts").css("text-align", "right");
		$(".formParts").css("width", "auto");
		
		$(".formBlock").css("display", "inline-block");
		$(".formBlock").css("margin-left", "30px");
		
		//累乗の数
		nNum = 10;
		
		//係数の作成
		var i=0;
		var j=0;
		
		coef = [];
		coef[1] = [1,1];

		for(i=2; i<=nNum; i++)
		{
			coef[i] = [];

			for(j=0; j<=i; j++)
			{
				if(j==0 || j==i)
				{
					coef[i][j] = 1;
				}
				else
				{
					coef[i][j] = coef[i-1][j-1] + coef[i-1][j];
				}
			}
		}
		
		//間隔
		span = Math.floor((gW/(coef[coef.length-1].length+2))/10)*10;
		
		//累乗の文字
		pow = ["⁰","¹","²","³","⁴","⁵","⁶","⁷","⁸","⁹","¹⁰"];
		
		//式の作成
		for(i=1; i<=nNum; i++)
		{
			var str0 = '(<span class="times">a</span>+<span class="times">b</span>)';
			
			if(i == 1)
			{
				document.getElementById("n1_4").innerHTML = '=<span class="formParts" id="c1_4_0">1</span><span class="times">a</span>+<span class="formParts" id="c1_4_1">1</span><span class="times">b</span>';
			}
			else
			{
				str0 += pow[i];
				
				//累乗が2以上の場合
				var str1 = '=(<span class="times">a</span>+<span class="times">b</span>)';
				
				var add = '(';
				add+=getPowForm(i-1, true, false);
				add += ')';
				
				str1 += add;
				
				document.getElementById("n"+i+"_1").innerHTML = str1;
				
				//計算式と結果式の係数の位置を合わせた状態にする
				setFormula(i);
			}
			
			document.getElementById("n"+i+"_0").innerHTML = str0;
		}
		
		nType = 4;
		nCnt = 0;
		
		//図のアニメーション設定
		gBack = new createjs.Shape();
		graphCont.addChild(gBack);
		
		//数字の位置
		var cX;
		var cY = (gH - ((nNum-1) * span))/2;
		
		var afterArray = [];
		
		//図用の文字
		for(i=1; i<=nNum; i++)
		{
			cX = (gW - ((coef[i].length-1) * span))/2;
			
			for(j=0; j<coef[i].length; j++)
			{
				var ca = createCoefText(coef[i][j]);
				ca.name = "c" + i + "_" + j + "a";
				var cb = createCoefText(coef[i][j]);
				cb.name = "c" + i + "_" + j + "b";
				
				graphCont.addChild(ca);
				
				afterArray.push(cb);
				
				ca.x = cX;
				ca.y = cY;
				cb.x = cX;
				cb.y = cY;
				
				cX += span;
			}
			
			cY += span;
		}
		
		//アニメーション用の数字は全面に来るように後で追加
		j = afterArray.length;
		for(i=0; i<j; i++)
		{
			graphCont.addChild(afterArray[i]);
		}
		
		//指定の項数までの背景の線
		drawGraphBack(nType);
		
		resetNumberDisplay(nType);
		
		for(i=1; i<=10; i++)
		{
			if(i != 4)
			{
			
				$("#b"+i).css("display", "none");
			}
			
			if(i >= 2)
			{
				document.getElementById("n"+i.toString()+"_3").style.textAlign = "right";
			}
		}
		
		resetPowNumHandler(4);
		
		
		document.getElementById("colorCheck").checked = false;
		document.getElementById("colorCheck").addEventListener("change", changeCheckHandler);
		
		document.getElementById('resetBtn').addEventListener('click', resetHandler);
		document.getElementById('logoImage').addEventListener('click', resetHandler);
		
		document.getElementById("playBtn").addEventListener("click", playAnimeHandler);
		
		document.getElementById("loopBtn").addEventListener("click", changeLoopHandler);
		
		document.getElementById("firstBtn").addEventListener("click", changeIndexHandler);
		document.getElementById("backBtn").addEventListener("click", changeIndexHandler);
		document.getElementById("nextBtn").addEventListener("click", changeIndexHandler);
		document.getElementById("lastBtn").addEventListener("click", changeIndexHandler);
		
		// 使用しないバルーン・非表示
		document.getElementById("selectBalloon_menu").style.display = "none";
		
		//nの設定
		document.getElementById("selectNum").addEventListener("click", openMenuBalloonHandler);
		
		$("#configBlock").css("display", "none");
		
		$(".blank").css("color", "#FFFFFF");
		
		
		
		createjs.Ticker.setFPS(30);
		createjs.Ticker.setPaused(true);
		
		createjs.Ticker.addEventListener("tick", tickerHandler);
		
		
		$("#contentCanvas").scrollTop(0);
		
		cs.update();
		
		setMenuMode(1, 250);
		
		checkVersionHandler("1.0.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function startScrollHandler(e)
{
	try
	{
		if(e.currentTarget.id == "sdPar")
		{
			scFlag = true;
		}
		else
		{
			scFlag = false;
		}
		
		changeScrollPosition();
		
		$("body").on("mouseup touchend", stopScrollHandler);
	}
	catch(e)
	{
		alert("startScrollHandler:" + e.toString());
	}
}

function stopScrollHandler(e)
{
	try
	{
		clearInterval(scTimer);
		
		$("body").off("mouseup touchend", stopScrollHandler);
	}
	catch(e)
	{
		alert("stopScrollHandler:" + e.toString());
	}
}

function changeScrollPosition()
{
	try
	{
		if(typeof scTimer != "undefined")
		{
			clearTimeout(scTimer);
		}
		
		if(scFlag)
		{
			$("#graphBlock").scrollTop($("#graphBlock").scrollTop()+10);
		}
		else
		{
			$("#graphBlock").scrollTop($("#graphBlock").scrollTop()-10);
		}
		
		scTimer = setTimeout(changeScrollPosition, 100);
	}
	catch(e)
	{
		alert("changeScrollPosition:" + e.toString());
	}
}


function setFormula(n)
{
	try
	{
		//計算式のx座標
		var pX;
		
		var i;
		var j=n;
		var k=0;
		var h=coef[n].length;
		
		for(i=0; i<h; i++)
		{
			//頭の文字式
			if(i == 0)
			{
				//イコール
				document.getElementById("n"+n + "_" + 2).appendChild(createFormulaParts("="));
				document.getElementById("n"+n + "_" + 4).appendChild(createFormulaParts("="));
				
				//係数
				var pA0 = createFormulaParts("1");
				var pC0 = createFormulaParts("1");
				pA0.setAttribute("id", "c"+n+"_2_0");
				pC0.setAttribute("id", "c"+n+"_4_0");
				
				document.getElementById("n"+n + "_" + 2).appendChild(pA0);
				document.getElementById("n"+n + "_" + 4).appendChild(pC0);
				
				//文字式部分
				var pStr0 = getPowPartsString(n, i);
				
				document.getElementById("n"+n + "_" + 2).appendChild(createFormulaParts(pStr0));
				document.getElementById("n"+n + "_" + 4).appendChild(createFormulaParts(pStr0));
			}
			//中の文字式
			else if(i == h-1)
			{
				//プラス
				document.getElementById("n"+n + "_" + 3).appendChild(createFormulaParts("+"));
				document.getElementById("n"+n + "_" + 4).appendChild(createFormulaParts("+"));
				
				//係数
				var pB1 = createFormulaParts("1");
				var pC1 = createFormulaParts("1");
				pB1.setAttribute("id", "c"+n+"_3_"+i);
				pC1.setAttribute("id", "c"+n+"_4_"+i);
				
				document.getElementById("n"+n + "_" + 3).appendChild(pB1);
				document.getElementById("n"+n + "_" + 4).appendChild(pC1);
				
				//文字部分
				var pStr1 = getPowPartsString(n, i);
				
				document.getElementById("n"+n + "_" + 3).appendChild(createFormulaParts(pStr1));
				document.getElementById("n"+n + "_" + 4).appendChild(createFormulaParts(pStr1));
			}
			//末尾の文字
			else
			{
				//プラス
				document.getElementById("n"+n + "_" + 2).appendChild(createFormulaParts("+"));
				if(i != 1)
				{
					document.getElementById("n"+n + "_" + 3).appendChild(createFormulaParts("+"));
				}
				document.getElementById("n"+n + "_" + 4).appendChild(createFormulaParts("+"));
				
				var pA2 = createFormulaParts(coef[n-1][i]);
				pA2.setAttribute("id", "c"+n+"_2_"+i);
				var pB2 = createFormulaParts(coef[n-1][i-1]);
				pB2.setAttribute("id", "c"+n+"_3_"+i);
				var pC2 = createFormulaParts(coef[n][i]);
				pC2.setAttribute("id", "c"+n+"_4_"+i);
				
				document.getElementById("n"+n + "_" + 2).appendChild(pA2);
				document.getElementById("n"+n + "_" + 3).appendChild(pB2);
				document.getElementById("n"+n + "_" + 4).appendChild(pC2);
				
				/*
				var leng = $(pC2).html().length;
				//alert(leng);
				
				var w = 18 + leng;
				
				$(pA2).css("width", w+"px");
				$(pB2).css("width", w+"px");
				$(pC2).css("width", w+"px");
				*/
				
				while($(pA2).html().length < $(pC2).html().length)
				{
					var str = $(pA2).html();
					str = '<span class="blank">_</span>'+str;
					$(pA2).html(str);
				}
				
				while($(pB2).html().length < $(pC2).html().length)
				{
					var str = $(pB2).html();
					str = '<span class="blank">_</span>'+str;
					$(pB2).html(str);
				}
				
				//文字部分
				var pStr2 = getPowPartsString(n, i);
				
				document.getElementById("n"+n + "_" + 2).appendChild(createFormulaParts(pStr2));
				document.getElementById("n"+n + "_" + 3).appendChild(createFormulaParts(pStr2));
				document.getElementById("n"+n + "_" + 4).appendChild(createFormulaParts(pStr2));
			}
			
		}
		
		
	}
	catch(e)
	{
		alert("setFormula:" + e.toString());
	}
}

function getPowPartsString(n, i)
{
	var str = "";
	
	if(i < coef[n].length-1)
	{
		str += '<span class="times">a</span>';
		if(n-i > 1)
		{
			str += pow[n-i];
		}
	}
	
	if(i > 0)
	{
		str += '<span class="times">b</span>';
		
		if(i > 1)
		{
			str += pow[i];
		}
	}
	
	return str;
}

function createFormulaParts(str)
{
	try
	{
		var d = document.createElement("span");
		d.setAttribute("class", "formParts");
		$(d).css("display", "inline-block");
		$(d).css("text-align", "right");
		d.innerHTML = str;
		return d;
	}
	catch(e)
	{
		alert("createDivBlock:" + e.toString());
	}
}

function openMenuBalloonHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			var inner = [1,2,3,4,5,6,7,8,9,10];
			var data = [1,2,3,4,5,6,7,8,9,10];

			openSelectBalloon("selectBalloon_menu", "menuBlock", e.currentTarget.id, inner, data, changeNumberData);

			$("#selectBalloon_menu").css("top", "5px");
			$("#selectTriangle").css("top", "10px");
		}
	}
	catch(e)
	{
		alert("openMenuBalloonHandler:"+e.toString());
	}
}

function changeNumberData(id, num)
{
	try
	{
		if(num != nType)
		{
			resetPowNumHandler(num);
		
			drawGraphBack(num);

			resetNumberDisplay(num);

			cs.update();
		}
	}
	catch(e)
	{
		alert("changeNumberData:" + e.toString());
	}
}

function changePowerHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			n = parseInt(e.target.id.substring(1, e.target.id.length));
			
			//別の累数をチェックした場合
			if(n != nType)
			{
				resetPowNumHandler(n);
				
				drawGraphBack(n);

				resetNumberDisplay(n);
			
				cs.update();
			}
			else
			{
				document.getElementById("n"+nType).checked = true;
			}
		}
		else
		{
			document.getElementById("n"+nType).checked = true;
		}
			
	}
	catch(e)
	{
		alert("changePowerHandler:" + e.toString());
	}
}

function resetPowNumHandler(n)
{
	try
	{
		$("#b"+nType).css("display", "none");
			
		$("#b"+n).css("display", "inline-block");
		
		nType = n;
		nCnt = 0;
		
		changeMenuTextBackHandler();	
	}
	catch(e)
	{
		alert("resetPowNumHandler:" + e.toString());
	}
}

function changeCheckHandler(e)
{
	changeMenuTextBackHandler();
	changeGraphTextBackHandler();
	cs.update();
}

function changeMenuTextBackHandler()
{
	for(var i=1; i<=nNum; i++)
	{
		var leng = coef[i].length;
		
		for(var j=0; j<leng; j++)
		{
			var n = coef[i][j];
			
			//左メニューのテキストの背景
			if(i == nType)
			{
				var c0;
				var c1;

				if(i == 1)
				{
					if(document.getElementById("colorCheck").checked)
					{
						if(n%2 == 0)
						{
							c0 = bc2;
						}
						else
						{
							c0 = bc3;
						}

						c1 = bc1;
					}
					else
					{
						c0 = bc0;
						c1 = bc1;
					}

					document.getElementById("c"+i+"_4_"+j).style.backgroundColor = c0;
					document.getElementById("c"+i+"_4_"+j).style.color = c1;
				}
				else
				{
					if(j<nCnt)
					{
						if(document.getElementById("colorCheck").checked)
						{
							if(n%2 == 0)
							{
								c0 = bc2;
							}
							else
							{
								c0 = bc3;
							}
						}
						else
						{
							c0 = bc0;	
						}

						c1 = bc1;

						document.getElementById("c"+i+"_4_"+j).style.backgroundColor = c0;
						document.getElementById("c"+i+"_4_"+j).style.color = c1;
					}
					else
					{
						document.getElementById("c"+i+"_4_"+j).style.backgroundColor = bc0;
						document.getElementById("c"+i+"_4_"+j).style.color = bc0;
					}
				}
			}
			else
			{
				document.getElementById("c"+i+"_4_"+j).style.backgroundColor = bc0;
				document.getElementById("c"+i+"_4_"+j).style.color = bc0;
			}
		}
	}
}

function changeGraphTextBackHandler()
{
	try
	{
		for(var i=1; i<=nNum; i++)
		{
			var leng = coef[i].length;
			for(var j=0; j<leng; j++)
			{
				//図の背景色
				var t = graphCont.getChildByName("c"+i+"_"+j+"a").getChildByName("text");
				var b = graphCont.getChildByName("c"+i+"_"+j+"a").getChildByName("back");

				var n = parseInt(t.text);

				b.graphics.clear();

				if(document.getElementById("colorCheck").checked)
				{
					var color;
					//偶数
					if(n%2 == 0)
					{
						color = bc2;	
					}
					//奇数
					else
					{
						color = bc3;
					}

					b.graphics.setStrokeStyle(0);
					b.graphics.beginStroke(color);
					b.graphics.beginFill(color);
					b.graphics.drawCircle(t.x+t.getBounds().width/2, t.y+t.getBounds().height/2-1, 16);
					b.graphics.endFill();
					b.graphics.endStroke();
				}
			}
		}
	}
	catch(e)
	{
		alert("changeGraphTextBackHandler:" + e.toString());
	}
}

function resetNumberDisplay(n)
{
	try
	{
		graphCont.getChildByName("c1_0a").visible = true;
		graphCont.getChildByName("c1_0b").visible = true;
		
		graphCont.getChildByName("c1_0b").x = graphCont.getChildByName("c1_0a").x;
		graphCont.getChildByName("c1_0b").y = graphCont.getChildByName("c1_0a").y;
		
		graphCont.getChildByName("c1_1a").visible = true;
		graphCont.getChildByName("c1_1b").visible = true;
		
		graphCont.getChildByName("c1_1b").x = graphCont.getChildByName("c1_1a").x;
		graphCont.getChildByName("c1_1b").y = graphCont.getChildByName("c1_1a").y;
		
		
		for(var i=2; i<=nNum; i++)
		{
			var c = coef[i].length;
			for(var j=0; j<c; j++)
			{
				var a = graphCont.getChildByName("c"+i+"_"+j+"a");
				var b = graphCont.getChildByName("c"+i+"_"+j+"b");
				
				if(i<n)
				{
					a.visible = true;
					b.visible = true;		
				}
				else
				{
					a.visible = false;
					b.visible = false;
				}
				
				b.x = a.x;
				b.y = a.y;
			}
		}
		
		createjs.Tween.removeAllTweens();
	}
	catch(e)
	{
		alert("resetNumberDisplay:" + e.toString());
	}
}

function drawGraphBack(n)
{
	try
	{
		gBack.graphics.clear();
		gBack.graphics.setStrokeStyle(1);
		gBack.graphics.beginStroke("#000000");
		
		for(i=1; i<n+1; i++)
		{
			cnt1 = coef[i].length;
			for(j=0; j<cnt1; j++)
			{
				var g0 = graphCont.getChildByName("c"+i+"_"+j+"a");
				
				//数字を結ぶ線
				if(i < n)
				{
					var g1 = graphCont.getChildByName("c"+(i+1)+"_"+j+"a");
					var g2 = graphCont.getChildByName("c"+(i+1)+"_"+(j+1)+"a");
					
					gBack.graphics.setStrokeStyle(1);
					gBack.graphics.beginStroke("#000000");
					gBack.graphics.moveTo(g0.x, g0.y);
					gBack.graphics.lineTo(g1.x, g1.y);
					gBack.graphics.moveTo(g0.x, g0.y);
					gBack.graphics.lineTo(g2.x, g2.y);
					gBack.graphics.endStroke();
				}
				
				//数字を見やすくするための背景
				gBack.graphics.setStrokeStyle(0);
				gBack.graphics.beginStroke("#FFFFFF");
				gBack.graphics.beginFill("#FFFFFF");
				gBack.graphics.drawRect(g0.x-10, g0.y-12, 20, 24);
				gBack.graphics.endStroke();
			}
		}
		
		gBack.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawGraphBack:"+e.toString());
	}
		
}

function getPowForm(n, f0, f1)
{
	try
	{
		var str = "";
		for(var i=1; i<=n+1; i++)
		{

			var add = "";

			if(i == 1)
			{
				if(f0)
				{
					add += '<span class="times">a</span>';
				}
				else
				{
					add += "a";
				}
				
				if(f1)
				{
					add = "1" + add;
				}
				
				if(n != 1)
				{
					add = add + pow[n];
				}
			}
			else if(i == n+1)
			{
				add = "+";
				
				if(f1)
				{
					add += "1";
				}
				
				if(f0)
				{
					add += '<span class="times">b</span>';
				}
				else
				{
					add += "b";
				}
				
				if(n != 1)
				{
					add += pow[n];
				}
			}
			else
			{
				add = "+" + coef[n][i-1];
				var nA = n+1-i;
				var nB = i-1;
				
				if(f0)
				{
					add = add + '<span class="times">a</span>';
				}
				else
				{
					add = add + 'a';
				}
					
				if(nA != 1)
				{
					add = add + pow[nA];
				}
				
				if(f0)
				{
					add = add + '<span class="times">b</span>';
				}
				else
				{
					add = add + 'b';
				}
				
				if(nB != 1)
				{
					add = add + pow[nB];
				}
			}

			str = str + add;
		}
		
		return str;
	}
	catch(e)
	{
		alert("getPowForm:" + e.toString());
	}

}

function createCoefText(n)
{
	try
	{
		var c = new createjs.Container();
		var t = new createjs.Text(n.toString(), "24px Times New Roman", "#000000");
		t.name = "text";
		var b = new createjs.Shape();
		b.name = "back";

		c.addChild(b);
		c.addChild(t);

		t.x = -t.getBounds().width/2;
		t.y = -t.getBounds().height/2;

		return c;
	}
	catch(e)
	{
		alert("createCoefText:" + e.toString());
	}
}

function playAnimeHandler(e)
{
	try
	{
		if(nType > 1 && animeFlag == false)
		{
			animeFlag = true;
			
			if(waitFlag == false)
			{
				createjs.Ticker.setPaused(false);
				startAnimeHandler();
			}
			else
			{
				startWait();
			}
			
			$("#playBtn").attr("src", "./img/stopIcon.png");
		}
		else if(nType != 1 && animeFlag == true)
		{
			animeFlag = false;
			
			if(waitFlag == false)
			{
				createjs.Ticker.setPaused(true);
			}
			else
			{
				clearInterval(timer);
			}
			
			$("#playBtn").attr("src", "./img/playIcon.png");
		}
	}
	catch(e)
	{
		alert("playAnimeHandler:" + e.toString());
	}
}

function startAnimeHandler()
{
	try
	{
		if(nCnt >= coef[nType].length)
		{
			nCnt = 0;
			resetNumberDisplay(nType);
		}
		
		//動かす位置
		var b = graphCont.getChildByName("c"+nType+"_"+nCnt+"b");
		var bX = b.x;
		var bY = b.y;

		var nBase;
		var sec;

		//先頭の数
		if(nCnt == 0)
		{
			var a0 = graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"b");
			
			nBase = graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"a");
			sec = 1500 * (Math.abs(bX-nBase.x)-Math.abs(a0.x-nBase.x))/Math.abs(bX-nBase.x);
			
			var tA0 = createjs.Tween.get(a0).to({x:bX, y:bY}, sec, createjs.Ease.linear).call(animeComplete);
		}
		//末尾の数
		else if(nCnt == coef[nType].length-1)
		{
			var a1 = graphCont.getChildByName("c"+(nType-1)+"_"+(nCnt-1)+"b");
			
			nBase = graphCont.getChildByName("c"+(nType-1)+"_"+(nCnt-1)+"a");
			sec = 1500 * (Math.abs(bX-nBase.x)-Math.abs(a1.x-nBase.x))/Math.abs(bX-nBase.x);

			var tA1 = createjs.Tween.get(a1).to({x:bX, y:bY}, sec, createjs.Ease.linear).call(animeComplete);
		}
		//途中
		else
		{
			var a2 = graphCont.getChildByName("c"+(nType-1)+"_"+(nCnt-1)+"b")
			var a3 = graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"b")
			
			nBase = graphCont.getChildByName("c"+(nType-1)+"_"+(nCnt-1)+"a");
			sec = 1500 * (Math.abs(bX-nBase.x) - Math.abs(a2.x-nBase.x))/Math.abs(bX-nBase.x);

			var tA2 = createjs.Tween.get(a2).to({x:bX, y:bY}, sec, createjs.Ease.linear).call(animeComplete);
			var tA3 = createjs.Tween.get(a3).to({x:bX, y:bY}, sec, createjs.Ease.linear);
		}
	}
	catch(e)
	{
		alert("startAnimeHandler:" + e.toString());
	}
}

function tickerHandler(e)
{
	cs.update();
}

function animeComplete(e)
{
	try
	{
		//元の位置に戻す
		if(nCnt < coef[nType].length-1)
		{
			graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"b").x = graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"a").x;
			graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"b").y = graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"a").y;
		}

		if(nCnt > 0)
		{
			graphCont.getChildByName("c"+(nType-1)+"_"+(nCnt-1)+"b").x = graphCont.getChildByName("c"+(nType-1)+"_"+(nCnt-1)+"a").x;
			graphCont.getChildByName("c"+(nType-1)+"_"+(nCnt-1)+"b").y = graphCont.getChildByName("c"+(nType-1)+"_"+(nCnt-1)+"a").y;
		}

		graphCont.getChildByName("c"+nType+"_"+nCnt+"a").visible = true;

		if(document.getElementById("colorCheck").checked)
		{
			if(coef[nType][nCnt]%2 == 0)
			{
				document.getElementById("c"+nType+"_4_"+nCnt).style.backgroundColor = bc2;
			}
			else
			{
				document.getElementById("c"+nType+"_4_"+nCnt).style.backgroundColor = bc3;
			}
		}
		else
		{
			document.getElementById("c"+nType+"_4_"+nCnt).style.backgroundColor = bc0;
		}

		document.getElementById("c"+nType+"_4_"+nCnt).style.color = bc1;
		
		createjs.Tween.removeAllTweens();
		
		nCnt++;

		if(nCnt >= coef[nType].length)
		{
			if(loopFlag == true)
			{
				waitFlag = true;
				startWait();
			}
			//アニメーション停止
			else
			{
				animeFlag = false;
				createjs.Ticker.setPaused(true);
				$("#playBtn").attr("src", "./img/playIcon.png");
			}
		}
		else
		{
			waitFlag = true;
			startWait();
		}
	}
	catch(e)
	{
		alert("animeComplete:" + e.toString());
	}
}

function startWait()
{
	try
	{
		timer = setInterval(waitCountDown, 100);
	}
	catch(e)
	{
		alert("startWait:" + e.toString());
	}
}

function waitCountDown()
{
	try
	{
		waitCount -= 1;
		
		if(waitCount <= 0)
		{
			clearInterval(timer);
			waitFlag = false;
			waitCount = 10;
			
			if(nCnt >= coef[nType].length)
			{
				if(loopFlag == true)
				{
					nCnt=0;
					resetNumberDisplay(nType);
					resetPowNumHandler(nType);
					drawGraphBack(nType);
					
					startAnimeHandler();
				}
				//アニメーション停止
				else
				{
					animeFlag = false;
					createjs.Ticker.setPaused(true);
					$("#playBtn").attr("src", "./img/playIcon.png");
				}
			}
			else
			{
				startAnimeHandler()
			}
		}
	}
	catch(e)
	{
		alert("waitCountDown:" + e.toString());
	}
}

function changeLoopHandler(e)
{
	try
	{
		if(loopFlag)
		{
			$("#loopBtn").attr("src", "./img/normalIcon.png");
		}
		else
		{
			$("#loopBtn").attr("src", "./img/autoIcon.png");
		}
		
		loopFlag = !loopFlag;
	}
	catch(e)
	{
		alert("changeLoopHandler:" + e.toString());
	}
}

function changeIndexHandler(e)
{
	try
	{
		if(animeFlag == false && nType > 1)
		{
			if(e.currentTarget.id == "firstBtn")
			{
				nCnt = 0;
			}
			else if(e.currentTarget.id == "backBtn")
			{
				if(nCnt > 0)
				{
					nCnt--;
				}
			}
			else if(e.currentTarget.id == "nextBtn")
			{
				if(nCnt <= nType)
				{
					nCnt++;
				}
			}
			else
			{
				nCnt = nType+1;
			}
			
			changeCoeffDisplay();
		
			cs.update();
		}
	}
	catch(e)
	{
		alert("changeIndexHandler:" + e.toString());
	}
}

function changeCoeffDisplay()
{
	try
	{

		for(var i=0; i<coef[nType].length; i++)
		{
			if(i<nCnt)
			{
				graphCont.getChildByName("c"+nType+"_"+i+"a").visible = true;
			}
			else
			{
				graphCont.getChildByName("c"+nType+"_"+i+"a").visible = false;
			}
		}
		
		changeMenuTextBackHandler();
		changeGraphTextBackHandler();
	}
	catch(e)
	{
		alert("changeCoeffDisplay:" + e.toString());
	}
}

function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = nType;
		array[1] = nCnt;
		array[2] = loopFlag;
		array[3] = waitFlag;
		array[4] = waitCount;
		array[5] = [];
		
		if(nType != 1)
		{
			if(nCnt == 0 || nCnt == nType)
			{
				array[5][0] = graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"b").x;
				array[5][1] = graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"b").y;
			}
			else
			{
				array[5][0] = graphCont.getChildByName("c"+(nType-1)+"_"+(nCnt-1)+"b").x;
				array[5][1] = graphCont.getChildByName("c"+(nType-1)+"_"+(nCnt-1)+"b").y;

				array[5][2] = graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"b").x;
				array[5][3] = graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"b").y;
			}
		}
		
		array[6] = $("#colorCheck").prop("checked");
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		createjs.Tween.removeAllTweens();
		tweenArray=[];
			
		nType = array[0];
		nCnt = array[1];
		loopFlag = array[2];
		waitFlag = array[3];
		waitCount = array[4];
		$("#colorCheck").prop("checked", array[6]);
		
		//累乗の選択状態
		$("#selectNum").html(array[0]);
		
		if(loopFlag == true)
		{
			$("#loopBtn").attr("src", "./img/autoIcon.png");
		}
		else
		{
			$("#loopBtn").attr("src", "./img/normalIcon.png");
		}
		
		resetPowNumHandler(array[0]);
		drawGraphBack(array[0]);
		resetNumberDisplay(array[0]);
		
		//図の係数の位置と表示
		if(nCnt > 0)
		{
			for(var i=0; i<coef[nType].length; i++)
			{
				if(i<nCnt)
				{
					graphCont.getChildByName("c"+nType+"_"+i+"a").visible = true;
				}
				else
				{
					graphCont.getChildByName("c"+nType+"_"+i+"a").visible = false;
				}
			}
		}
		
		if(nCnt == 0 || nCnt == nType)
		{
			graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"b").x = array[5][0];
			graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"b").y = array[5][1];
		}
		else
		{
			graphCont.getChildByName("c"+(nType-1)+"_"+(nCnt-1)+"b").x = array[5][0];
			graphCont.getChildByName("c"+(nType-1)+"_"+(nCnt-1)+"b").y = array[5][1];
			
			graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"b").x = array[5][2];
			graphCont.getChildByName("c"+(nType-1)+"_"+nCnt+"b").y = array[5][3];
		}
		
		changeMenuTextBackHandler();
		changeGraphTextBackHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

function resetHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			$("#selectNum").html(4);
			
			resetPowNumHandler(4);
				
			drawGraphBack(4);

			resetNumberDisplay(4);

			nType = 4;
			
			
			createjs.Tween.removeAllTweens();
			tweenArray=[];
			
			loopFlag = true;
			waitFlag = false;
			waitCount = 10;
			
			$("#loopBtn").attr("src", "./img/autoIcon.png");
			
			$("#colorCheck").prop("checked", false);
			
			changeMenuTextBackHandler();
			changeGraphTextBackHandler();
			
			cs.update();
		}
	}
	catch(e)
	{
		alert('resetHandler:' + e.toString());
	}
}
