// JavaScript Document
var _exData;

function changeInDeTable(a, b, c, d)
{
	try
	{
		//初期化
		_exData = [];
		
		_calcDefferential(a, b, c, d);
		
		_changeTableDisplay(a, b, c, d);
	}
	catch(e)
	{
		alert("changeInDeTable:" + e.toString());
	}
}

function _calcDefferential(a0, b0, c0, d0)
{
	try
	{
		
		
		var a;
		var b;
		var c;
		
		//三次関数
		if(a0 != 0)
		{
			a = 3 * a0;
			b = 2 * b0;
			c = c0;
			
			//解
			var r0 = (-b-Math.sqrt(b*b-4*a*c))/(2 * a);
			var r1 = (-b+Math.sqrt(b*b-4*a*c))/(2 * a);
			
			//
			if(b*b-4*a*c >= 0)
			{
				if(r0 == r1)
				{
					_exData.push(r0);
				}
				else
				{
					if(r0 < r1)
					{
						_exData.push(r0);
						_exData.push(r1);
					}
					else
					{
						_exData.push(r1);
						_exData.push(r0);
					}
					
				}
			}
		}
		//二次関数
		else if(b0 != 0)
		{
			a = 2 * b0;
			b = c0;
			
			var r = -b/a;
			
			_exData.push(r);
		}
	}
	catch(e)
	{
		alert("_calcDifferential"+e.toString());
	}
}

function _changeTableDisplay(a, b, c, d)
{
	try
	{
		if(_exData.length == 0)
		{
			//矢印
			$("#td1_1").html(_getDifferentialString(0, a, b, c));
			_changeArrowImage("img2_1", 0, a, b, c);
			
			//セルの表示切替
			//極値
			$("#row2").css("visibility", "collapse");
			$("#td0_2").css("visibility", "collapse");
			$("#td1_2").css("visibility", "collapse");
			$("#td2_2").css("visibility", "collapse");
			
			$("#row3").css("visibility", "collapse");
			$("#td0_3").css("visibility", "collapse");
			$("#td1_3").css("visibility", "collapse");
			$("#td2_3").css("visibility", "collapse");
			//極値
			$("#row4").css("visibility", "collapse");
			$("#td0_4").css("visibility", "collapse");
			$("#td1_4").css("visibility", "collapse");
			$("#td2_4").css("visibility", "collapse");
			
			$("#row5").css("visibility", "collapse");
			$("#td0_5").css("visibility", "collapse");
			$("#td1_5").css("visibility", "collapse");
			$("#td2_5").css("visibility", "collapse");
			
		}
		else if(_exData.length == 1)
		{
			//矢印
			$("#td1_1").html(_getDifferentialString(_exData[0]-1, a, b, c));
			_changeArrowImage("img2_1", _exData[0]-1, a, b, c);

			//極値
			$("#td0_2").html(Math.round(_exData[0] * 100)/100);
			$("#td1_2").html("0");
			$("#td2_2").html(Math.round(_getFormulaResult(_exData[0], a, b, c, d)*100)/100);
			
			//矢印
			$("#td1_3").html(_getDifferentialString(_exData[0]+1, a, b, c));
			_changeArrowImage("img2_3", _exData[0]+1, a, b, c);
			
			//セルの表示切替
			//極値
			$("#row2").css("visibility", "visible");
			$("#td0_2").css("visibility", "visible");
			$("#td1_2").css("visibility", "visible");
			$("#td2_2").css("visibility", "visible");
			
			$("#row3").css("visibility", "visible");
			$("#td0_3").css("visibility", "visible");
			$("#td1_3").css("visibility", "visible");
			$("#td2_3").css("visibility", "visible");
			
			//極値
			$("#row4").css("visibility", "collapse");
			$("#td0_4").css("visibility", "collapse");
			$("#td1_4").css("visibility", "collapse");
			$("#td2_4").css("visibility", "collapse");
			
			$("#row5").css("visibility", "collapse");
			$("#td0_5").css("visibility", "collapse");
			$("#td1_5").css("visibility", "collapse");
			$("#td2_5").css("visibility", "collapse");
		}
		else
		{
			//矢印
			$("#td1_1").html(_getDifferentialString(_exData[0]-1, a, b, c));
			_changeArrowImage("img2_1", _exData[0]-1, a, b, c);
			
			//極値
			$("#td0_2").html(Math.round(_exData[0] * 100)/100);
			$("#td1_2").html("0");
			$("#td2_2").html(Math.round(_getFormulaResult(_exData[0], a, b, c, d)*100)/100);
			
			//矢印
			$("#td1_3").html(_getDifferentialString((_exData[0]+_exData[1])/2, a, b, c));
			_changeArrowImage("img2_3", (_exData[0]+_exData[1])/2, a, b, c);
			
			//極値
			$("#td0_4").html(Math.round(_exData[1] * 100)/100);
			$("#td1_4").html("0");
			$("#td2_4").html(Math.round(_getFormulaResult(_exData[1], a, b, c, d)*100)/100);
			
			//矢印
			$("#td1_5").html(_getDifferentialString(_exData[1]+1, a, b, c));
			_changeArrowImage("img2_5", _exData[1]+1, a, b, c);
		
			//セルの表示切替
			//極値
			$("#row2").css("visibility", "visible");
			$("#td0_2").css("visibility", "visible");
			$("#td1_2").css("visibility", "visible");
			$("#td2_2").css("visibility", "visible");
			
			$("#row3").css("visibility", "visible");
			$("#td0_3").css("visibility", "visible");
			$("#td1_3").css("visibility", "visible");
			$("#td2_3").css("visibility", "visible");
			
			//極値
			$("#row4").css("visibility", "visible");
			$("#td0_4").css("visibility", "visible");
			$("#td1_4").css("visibility", "visible");
			$("#td2_4").css("visibility", "visible");
			
			$("#row5").css("visibility", "visible");
			$("#td0_5").css("visibility", "visible");
			$("#td1_5").css("visibility", "visible");
			$("#td2_5").css("visibility", "visible");
		}
	}
	catch(e)
	{
		alert("_changeTableDisplay:" + e.toString());
	}
}

function _getFormulaResult(n, a, b, c, d)
{
	try
	{
		var r = a * n * n * n + b * n * n + c * n + d;
		
		return r;
	}
	catch(e)
	{
		alert("getFormulaResult:" + e.toString());
	}
}

//矢印の変更
function _changeArrowImage(id, n, a, b, c)
{
	try
	{
		var f = _getDifferentialResult(n, a, b, c);
		
		if(f > 0)
		{
			$("#"+id).attr("src", "./img/arrowUp.png");
		}
		else
		{
			$("#"+id).attr("src", "./img/arrowDown.png");
		}
	}
	catch(e)
	{
		alert("_chagneArrowImage:" + e.toString());
	}
}


function _getDifferentialString(x, a, b, c)
{
	try
	{
		var n = _getDifferentialResult(x, a, b, c);
		
		if(n == 0)
		{
			return "0";
		}
		else if(n > 0)
		{
			return "+";
		}
		else
		{
			return "-";
		}
	}
	catch(e)
	{
		alert("_getDifferentialString:" + e.toString());
	}
}

//微分した数式の値
function _getDifferentialResult(x, a, b, c)
{
	try
	{
		var n = 3 * a * x * x + 2 * b * x  + c;
		
		return n;
	}
	catch(e)
	{
		alert("_getDifferentialResult:" + e.toString());
	}
}

